package jp.sourceforge.freegantt.swing;

import java.awt.Component;
import java.awt.Rectangle;

import javax.swing.DefaultListCellRenderer;
import javax.swing.JComboBox;
import javax.swing.JList;
import javax.swing.plaf.basic.BasicComboBoxUI;
import javax.swing.plaf.basic.BasicComboPopup;
import javax.swing.plaf.basic.ComboPopup;

import jp.sourceforge.freegantt.data.Member;
import jp.sourceforge.freegantt.data.Project;

public class TaskMemberCellEditor extends JComboBox {
	private static final long serialVersionUID = -2162048356937129713L;

	Project project;

	public TaskMemberCellEditor(Project project) {
		super();
		this.project = project;
		setModel(project.getTaskMemberComboBoxModel());
		setRenderer(new TaskMemberListCellRenderer());
		setUI(new StyledComboBoxUI());
	}
	
	class TaskMemberListCellRenderer extends DefaultListCellRenderer {
		private static final long serialVersionUID = -8961880883385311841L;

		@Override
		public Component getListCellRendererComponent(JList list, Object value,
				int index, boolean isSelected, boolean cellHasFocus) {
			Object stringValue = ((value == null) ? "（なし）" : ((Member)value).getName());
			return super.getListCellRendererComponent(list, stringValue, index, isSelected,
					cellHasFocus);
		}
	}
	
	class StyledComboBoxUI extends BasicComboBoxUI {
		protected ComboPopup createPopup() {
			BasicComboPopup popup = new BasicComboPopup(comboBox) {
				private static final long serialVersionUID = 9216393246368274687L;

				@Override
				protected Rectangle computePopupBounds(int px, int py, int pw,
						int ph) {
					return super
							.computePopupBounds(px, py, Math.max(
									comboBox.getPreferredSize().width, pw), ph);
				}
			};
			popup.getAccessibleContext().setAccessibleParent(comboBox);
			return popup;
		}
	}
}
